function [jmin,jmax,imin,imax] = LimitDet(M)
%Function that determines the limits of a matrix with a NaN rim
imin=0; imax=0; jmin=0; jmax=0;
[J,I]=size(M);
% figure,imagesc(M), axis equal, axis tight
IsGood=zeros(size(M));
for j=1:J
    for i=1:I
        if isnan(M(j,i))==0 IsGood(j,i)=1; end
    end % for j
end % for i

RowGood=sum(IsGood,1); RowGood2=RowGood(RowGood~=0); 
ColGood=sum(IsGood,2); ColGood2=ColGood(ColGood~=0);

RowGoodMode=mode(RowGood2);
ColGoodMode=mode(ColGood2);

ColPrec=0;
for j=1:J
    if ColGood(j)==ColGoodMode
        jmax=j;
        if ColPrec<ColGoodMode;
            jmin=j;
        end
    end
    ColPrec=ColGood(j);
end

RowPrec=0;
for i=1:I
    if RowGood(i)>=RowGoodMode
        imax=i;
        if RowPrec<RowGoodMode;
            imin=i;
        end
    end
    RowPrec=RowGood(i);
end

if jmin==0; jmin=find(ColGood>0); jmin=jmin(1); end
% jmin,jmax,imin,imax, pause
