function [Xpx,Ypx,im]=ReadImagesTif(im_fold,fileroot,field,dt,zerostr,im_app)

% Xpx:  X mesh in pixels
% Ypx:  Y mesh in pixels
% im1:  first image of the pair
% im2:  second image of the pair

field1str=num2str(field);
FileName1=[im_fold fileroot zerostr(1:length(zerostr)-length(field1str)) field1str im_app];
im1 = double(imread(FileName1));
field2str=num2str(field+dt);
FileName2=[im_fold fileroot zerostr(1:length(zerostr)-length(field2str)) field2str im_app];
im2 = double(imread(FileName2));
[J,I] = size(im1);
[Xpx,Ypx]=meshgrid(1:I,1:J);
im = zeros(J,I,2);
im(:,:,1) = im1;
im(:,:,2) = im2;

end % end function

