function [g]=gaussian2De_2(Ny,Nx)
if nargin<2, Nx=Ny; end
% 2D gaussian function
[X,Y]=meshgrid(-(Nx-1)/2:(Nx-1)/2,-(Ny-1)/2:(Ny-1)/2);
r=sqrt(X.^2+Y.^2);
r=r/(Nx-1)*2;
g=exp(-2*r.^2);
end %end function